signature LOCATION =
sig
   type location
   val dummy : location
   val mkLocation : int * int -> location
   val toString : location -> string
end


structure Location :> LOCATION
=
struct

    type location = {from:int, to:int}

    val dummy = {from = ~1, to = ~1}

    fun mkLocation (left, right) = {from=left, to=right}

    fun merge (left:location, right:location) =
	{from = #from left, to = #to right}

    fun toString (loc:location) = 
	(Int.toString (#from loc)) ^ " - " ^ (Int.toString (#to loc))
	
end