functor Parsing (structure Absyn : ABSTRACT_SYNTAX) :> 
    PARSE where Absyn = Absyn 
    =
struct

    structure NUMODLrVals =
        NUMODLrValsFun(structure Token = LrParser.Token
		       structure Absyn = Absyn)

    structure NUMODLex =
        NUMODLexFun(structure Tokens = NUMODLrVals.Tokens)

    structure NUMODParser=
        Join(structure ParserData = NUMODLrVals.ParserData
             structure Lex=NUMODLex
             structure LrParser=LrParser) 

    structure Absyn = Absyn

    open TextIO;
	
    exception ParseError = NUMODParser.ParseError
    val input = fn (istream,n) => inputLine istream
 
    fun invoke lexstream =
      let
        fun print_error (s,i:NUMODParser.pos,_) =
          output(stdOut,"Error, line "^(Int.toString i)^", "^s^"\n")
      in
        NUMODParser.parse(0,lexstream,print_error,())
      end
 
    fun parse_stream stream =
      let
        val _ = LineNumber.reset()
        val lexer = NUMODParser.makeLexer (fn x => input(stream, x))
        val (result, lexer) = invoke lexer
      in
        result
      end
 
 
    fun fromFile file =
        parse_stream (TextIO.openIn file)
	
end