structure SupportSet :> 
  SUPPORT where type support = Var.VarSet.set 
=
struct

    type support = Var.VarSet.set

    val empty = Var.VarSet.empty
	
    fun singleton (v : Var.var) =
	Var.VarSet.singleton v

    fun add (v, s) = Var.VarSet.add' (v, s)

    fun remove (v, s) = Var.VarSet.delete (s, v)

    fun agrees (v, s) = Var.VarSet.member (s, v)

    fun toString (C : support) =
	let val lst = Var.VarSet.listItems C
	    fun printSupport ([]) = ""
	      | printSupport ([x]) = Var.toString x
	      | printSupport (x::xs) = 
		let val s = printSupport xs
		in
		    (Var.toString x)^","^s
		end
	in
	    printSupport lst
	end

    fun equal (C, D) = 
	Var.VarSet.equal (C, D)

    val leq = Var.VarSet.isSubset

    val toList = Var.VarSet.listItems

    fun fromList l = List.foldl Var.VarSet.add' Var.VarSet.empty l

    fun isElement (v, s) = Var.VarSet.member (s, v)
end
