signature TYPES =
sig
    type var = Var.var
    type location = Location.location
    type support 
	
    datatype tp = 
	UNIT
      |	NAT 
      | BOOL
      | NATLIST
      | VAR of var
      | PROD of tp * tp
      | ARROW of tp * tp 
      | NARROW of tp * tp
      | BOX of support * tp
      | DIA of support * tp

    datatype ltp = 
	LUNIT of location
      |	LNAT  of location
      | LBOOL of location
      | LNATLIST of location
      | LVAR of var * location
      | LPROD of ltp * ltp * location
      | LARROW of ltp * ltp * location
      | LNARROW of ltp * ltp * location
      | LBOX of support * ltp * location
      | LDIA of support * ltp * location

    val toString : tp -> string
    val fromLtp: ltp -> tp
    val getLoc : ltp -> location
    val equal : tp * tp -> bool
    val inType : var * tp -> bool

end